var gui=require('nw.gui');

function LliurexGuard(){
     // this domain list will be get by n4d!!!
     this.BlackLists={"domainLists":[]};
     this.WhiteLists={"domainLists":[]};
}

LliurexGuard.prototype.getStatus=function getStatus(){
        $.xmlrpc({
			url: 'https://'+sessionStorage.server+':9779',
			methodName: 'getStatus',
			params: ["", "LliurexGuard"],
			success: function(response,status,jqXHR){
				console.log(response[0]);
				var optionRadio=null;
				if (response[0]["config"]=="allow") 
                    optionRadio="#permissive";
				else if (response[0]["config"]=="deny") 
                    optionRadio="#restrictive";
					
				$(optionRadio).attr("checked","checked");
				
			},
			error: function(jqXHR, status, error) {
				//alert("Status: "+status+"\nError: N4d server is down"+error);
                $("#snack").attr("data-content", i18n.gettext("N4d.Error.Connection"));
                $("#snack").snackbar("show");
			}
		})
        
}

	

LliurexGuard.prototype.drawBlackList=function drawBlackList(){
        var self=this;
        
        $.xmlrpc({
			url: 'https://'+sessionStorage.server+':9779',
			methodName: 'getBlackList',
			params: ["", "LliurexGuard"],
			success: function(response,status,jqXHR){
                self.BlackLists=response[0]["response"];
				
                for (i in self.BlackLists["domainLists"]){
                        var item=self.BlackLists["domainLists"][i];                        
                        var divcb=$(document.createElement("div")).addClass("checkbox checkbox-primary").css("border-top","1px solid #cccccc");
                        var label=$(document.createElement("label"));
                        var input=$(document.createElement("input")).attr("name", "blacklistGroup").attr("file",item["file"]).attr("id", item["file"]).attr("type", "checkbox");
                        if (item["active"]=="True") $(input).attr("checked", "checked");
                        //var spanDesc=$(document.createElement("span")).css("{padding:0px; }");
                        var spanDesc=$(document.createElement("span")).css({"padding":"0px", "margin-left":"20px", "top":"-3px", "width":"400px;"});
                        $(spanDesc).html(i18n.gettext(item["description_short"]));
                        
                        var divdesc=$(document.createElement("div")).addClass("radiodescription").html(i18n.gettext(item["description"]));
                        
                        customBt=null;
                        if (item["file"]=="z_custom.list") {
                                var customBt=$(document.createElement("button")).addClass("btn btn-primary btn-xs pull-right").html(i18n.gettext("customize.list"));
                                $(customBt).attr("data-toggle", "modal").attr("data-target","#editCustomList");                        
                                $(label).append(input, spanDesc);
                                $(divcb).append(label, divdesc, customBt);
                                $(divcb).css("min-height","80px");
                                $(BlackList).prepend(divcb);
                        } else {
                              $(label).append(input, spanDesc);
                              $(divcb).append(label, divdesc, customBt);
                              $(BlackList).append(divcb);
                        }
                }
                $.material.init();
			},
			error: function(jqXHR, status, error) {
				//alert("Status: "+status+"\nError: N4d server is down"+error);
                $("#snack").attr("data-content", i18n.gettext("N4d.Error.Connection"));
                $("#snack").snackbar("show");
			}
		})
}



LliurexGuard.prototype.drawWhiteList=function drawWhiteList(){
        var self=this;
        
        $.xmlrpc({
			url: 'https://'+sessionStorage.server+':9779',
			methodName: 'getWhiteList',
			params: ["", "LliurexGuard"],
			success: function(response,status,jqXHR){
                self.WhiteLists=response[0]["response"];
                
                  for (i in self.WhiteLists["domainLists"]){
                
                        var item=self.WhiteLists["domainLists"][i];
                        
                        var divcb=$(document.createElement("div")).addClass("checkbox checkbox-primary").css("border-top","1px solid #cccccc");
                        var label=$(document.createElement("label"));
                        var input=$(document.createElement("input")).attr("name", "whitelistGroup").attr("file",item["file"]).attr("classdomain",item["domain"]).attr("id", item["file"]).attr("type", "checkbox");
                        if (item["active"]=="True") $(input).attr("checked", "checked");
                        //var spanDesc=$(document.createElement("span")).css("{padding:0px; }");
                        var spanDesc=$(document.createElement("span")).css({"padding":"0px", "margin-left":"20px", "top":"-3px", "width":"400px;"});
                        var desc_short=i18n.gettext(item["description_short"]);
                        if (item["domain"]) desc_short=desc_short+" ("+item["domain"]+")";
                        $(spanDesc).html(desc_short);
                        
                        var divdesc=$(document.createElement("div")).addClass("radiodescription").html(i18n.gettext(item["description"]));
                        
                        customBt=null;
                        if (item["file"]=="z_customwhite.list") {
                                var customBt=$(document.createElement("button")).addClass("btn btn-primary btn-xs pull-right").html(i18n.gettext("customize.list"));
                                $(customBt).attr("data-toggle", "modal").attr("data-target","#editCustomList");                        
                                
                                $(label).append(input, spanDesc);
                                $(divcb).append(label, divdesc, customBt);
                                $(divcb).css("min-height","80px");
                                $(WhiteList).prepend(divcb);
                                
                                
                        } else {
                              $(label).append(input, spanDesc);
                              $(divcb).append(label, divdesc, customBt);
                              $(WhiteList).append(divcb);
                         }
                }
        
                $.material.init();
                 
			},
			error: function(jqXHR, status, error) {
                $("#snack").attr("data-content", i18n.gettext("N4d.Error.Connection"));
                $("#snack").snackbar("show");
				//alert("Status: "+status+"\nError: N4d server is down"+error);
			}
		})
        
        
}
    

LliurexGuard.prototype.bindMenuEvents=function bindMenuEvents(){
        $("#MenuBt").bind("click", function(event){
                event.stopPropagation();
                var menu_hidden=$("#menu").hasClass("hidden");
                if (menu_hidden) $("#menu").removeClass("hidden").addClass("shown");
                else $("#menu").removeClass("shown").addClass("hidden");
        });
        
        $("body").bind("click", function(){
                $("#menu").removeClass("shown").addClass("hidden");
        });
        
        $(".optionMenu").bind("click", function(){
                $(".mainContainer").hide();
                var target=$(this).attr("target");
                $("#"+target).show();
        });
}
 

LliurexGuard.prototype.prepareModal=function prepareModal(){
        var self=this;
        // On show dialog let's read file content
        $("#editCustomList").on("shown.bs.modal", function(){
                // Determine if we are on white or black list editing
                
                var header, content, targetListFile;

                if ($("#blackListConfig").css("display")=="block") {
                        // Working on blacklist
                        header=i18n.gettext("Edit.Blacklist");
                        targetListFile="z_custom.list";
                }
                else {
                        // Working on whitelist
                        header=i18n.gettext("Edit.Whitelistlist");
                        targetListFile="z_customwhite.list";           
                }
             
                $.xmlrpc({
                        url: 'https://'+sessionStorage.server+':9779',
                        methodName: 'getCustomList',
                        params: ["", "LliurexGuard", targetListFile],
                        success: function(response,status,jqXHR){
                            content=response[0]["response"];
                            $("#myModalLabel").html(header);
                            //$("#customList").html(content);
                            $("#customList").val(content);
                            $("#customList").removeAttr("readonly");
                                   
                            // Binding Savelist button
                            $("#savelist").unbind("click");
                            $("#savelist").bind("click", function(){
                                var content=$("#customList").val();
                                
                                 $.xmlrpc({
                                        url: 'https://'+sessionStorage.server+':9779',
                                        methodName: 'setCustomList',
                                        params: [[sessionStorage.username , sessionStorage.password], "LliurexGuard", content, targetListFile],
                                        success: function(response,status,jqXHR){
                                                $("#snack").attr("data-content", i18n.gettext("File Saved"));
                                                 
                                                 $("#snack").snackbar("show");
                                                
                                                },
                                        error: function(jqXHR, status, error) {
                                                $("#snack").attr("data-content", i18n.gettext("N4d.Error.Connection"));
                                                $("#snack").snackbar("show");
                                                //alert("Status: "+status+"\nError: N4d server is down"+error);
                                        }
                                })
                                
                                
                                //alert("Saving to "+targetListFile+" "+content);
                            });
                            
                            $.material.init();
                        },
                        error: function(jqXHR, status, error) {
                                $("#snack").attr("data-content", i18n.gettext("N4d.Error.Connection"));
                                $("#snack").snackbar("show");
                            //alert("Status: "+status+"\nError: N4d server is down"+error);
                        }
                })
             
           });
        
        };



LliurexGuard.prototype.bindModalEvents=function bindModalEvents(){
        var self=this;
        
        $("#editCustomList").on("hidden.bs.modal", function(){
                $("#editCustomList").remove();
                $("body").append('	<div class="modal fade" id="editCustomList" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">\
                <div class="modal-dialog" role="document"> \
                  <div class="modal-content">\
                    <div class="modal-header">\
                      <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>\
                      <h4 class="modal-title" id="myModalLabel"></h4>\
                    </div>\
                    <div class="modal-body">\
                      <textarea  id="customList" class="form-control" rows="13" readonly></textarea>			\
                    </div>\
                    <div class="modal-footer">\
                      <button type="button" class="btn btn-default" data-dismiss="modal">'+i18n.gettext("Close")+'</button>\
                      <button type="button" class="btn btn-primary" data-dismiss="modal" id="savelist">'+i18n.gettext("Save.changes")+'</button>\
                    </div>\
                  </div>\
                </div>\
              </div>\ ');
             self.prepareModal();
        })
        
        self.prepareModal();

}


LliurexGuard.prototype.ApplyPolicy=function ApplyPolicy(){
        var policy =$("#radioPolicy input:radio:checked").val();
        
        var blackchecks=$("#BlackList").find("input[type='checkbox']:checked");
        var whitechecks=$("#WhiteList").find("input[type='checkbox']:checked");
        var blacklist=[]
        var whitelist=[]
        var n4dparams={};
        var classdomain="";
        for (i=0;i<blackchecks.length;i++)
                blacklist.push($(blackchecks[i]).attr("file"));
        
        for (i=0;i<whitechecks.length;i++){
                var file=$(whitechecks[i]).attr("file");
                if (typeof(file)!=="undefined")
                        whitelist.push(file);
                        
                var domain=$(whitechecks[i]).attr("classdomain");
                if (typeof(domain)!=="undefined")
                        classdomain=domain;
                        // No cal fer el push en esta llista, sino tractar-ho com a una variable apart que
                        // S'enviarà com a altre paràmetre
        }
        
        n4dparams={
                "policy":policy,
                "whitelist":whitelist,
                "blacklist":blacklist,
                "classdomain":classdomain        
        };
        
        
        // Now let's call n4d method to apply Policy
        
        $("body").css("cursor", "wait");
        $.xmlrpc({
			url: 'https://'+sessionStorage.server+':9779',
			methodName: 'applyPolicy',
			params: [[sessionStorage.username , sessionStorage.password], "LliurexGuard", n4dparams],
			success: function(response,status,jqXHR){
                $("body").css("cursor", "auto");
                var message="";
                if (response[0]["status"]=="true") message=i18n.gettext("config.applied.ok");
                else message=i18n.gettext("config.applied.error");
                
                $("#snack").attr("data-content", message);
                $("#snack").snackbar("show");
                
                 
			},
			error: function(jqXHR, status, error) {
                $("#snack").attr("data-content", i18n.gettext("N4d.Error.Connection"));
                $("#snack").snackbar("show");
			}
		})
        
}

LliurexGuard.prototype.bindEvents=function bindEvents(){
        var self=this;
        $("#ApplyButtonPolicy").bind("click",function(){
                self.ApplyPolicy();
                });
        
        $("#ApplyButtonWhitelist").bind("click",function(){
                self.ApplyPolicy();
                });
              
        $("#ApplyButtonBlacklist").bind("click",function(){
                self.ApplyPolicy();
                });
        
        $("#appQuit").bind("click", function(){
            gui.App.quit();
          });
		
		$("#CancelButtonPolicy").bind("click", function(){
            alert("CancelButtonPolicy");
          });
		
		$("#CancelButtonWhitelist").bind("click", function(){
			var height=($("#whiteListConfig").find(".jumbotron").css("height"));
			$("#whiteListConfig").find(".jumbotron").css("height", height);
			$("#WhiteList").fadeOut(100);
			$("#WhiteList").empty();
			self.drawWhiteList();
			$("#WhiteList").fadeIn(100);
          });
		
		$("#CancelButtonBlacklist").bind("click", function(){
			//$("#BlackList").fadeOut(300);
			var height=($("#blackListConfig").find(".jumbotron").css("height"));
			$("#blackListConfig").find(".jumbotron").css("height", height);
			$("#BlackList").fadeOut(100);
			$("#BlackList").empty();
			self.drawBlackList();
			$("#BlackList").fadeIn(100);
			
          });
}
 
$(document).ready(function() {

        
        guard=new LliurexGuard();
        guard.getStatus();
        guard.drawBlackList();
        guard.drawWhiteList();
        //ApplyButtonWhitelist
        guard.bindEvents();
        guard.bindModalEvents();
        guard.bindMenuEvents();
        
         $('#windowManagement').data('size','big');
        
	    $.material.init();
        $.snackbar();

})


$(window).scroll(function(){
    if($(document).scrollTop() > 0)
    {
        if($('#windowManagement').data('size') == 'big')
        {
            $('#windowManagement').data('size','small');
            $('#windowManagement').stop().animate({
                height:'40px'
            },600);
        }
    }
    else
    {
        if($('#windowManagement').data('size') == 'small')
        {
            $('#windowManagement').data('size','big');
            $('#windowManagement').stop().animate({
                height:'100px'
            },600);
        }  
    }
});

